<template>
  <div>
    <textarea
      name="json"
      id="jsonText"
      cols="30"
      rows="10"
      v-model="jsonStr"
      @change="updateJson()"
    ></textarea>

    <button class="btn" @click="formatJson">Format</button>
  </div>
</template>

<script>
export default {
  props: {
    initJsonStr: String,
  },
  data() {
    return {
      jsonStr: this.initJsonStr,
    };
  },
  methods: {
    updateJson() {
      try {
        var parsedJson = JSON.parse(this.jsonStr);
        this.$emit("updateJson", parsedJson);
      } catch (e) {
        this.$emit("triggerError", e.message);
      }
    },
    formatJson() {
      try {
        var parsedJson = JSON.parse(this.jsonStr);
        this.jsonStr = JSON.stringify(parsedJson, null, 4);
        this.$emit("updateJson", parsedJson);
      } catch (e) {
        this.$emit("triggerError", e.message);
      }
    },
  },
  mounted(){
    this.updateJson()
 },
};
</script>

<style lang="css" >
textarea {
  font-family: monospace;
}
</style>
